summaryrefslogtreecommitdiff
path: root/ssh-tmux.sh
diff options
context:
space:
mode:
Diffstat (limited to 'ssh-tmux.sh')
-rwxr-xr-xssh-tmux.sh48
1 files changed, 48 insertions, 0 deletions
diff --git a/ssh-tmux.sh b/ssh-tmux.sh
new file mode 100755
index 0000000..a7a7bac
--- /dev/null
+++ b/ssh-tmux.sh
@@ -0,0 +1,48 @@
+#! /bin/sh
+
+# Copyright (c) 2022 Stefan Kreutz <mail@skreutz.com>
+#
+# Permission to use, copy, modify, and distribute this software for any
+# purpose with or without fee is hereby granted, provided that the above
+# copyright notice and this permission notice appear in all copies.
+#
+# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
+# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+
+set -o errexit
+set -o nounset
+
+err_exit() {
+ print -u2 -- "$*"
+ exit 1
+}
+
+while getopts :hds:n: option; do
+ case "$option" in
+ d) detach=true ;;
+ s) session="$OPTARG" ;;
+ n) window="$OPTARG" ;;
+ :) err_exit "missing argument for option -$OPTARG" ;;
+ ?) err_exit "illegal option: -$OPTARG" ;;
+ esac
+done
+shift $((OPTIND-1))
+
+if [ $# -eq 0 ]; then
+ err_exit "missing host argument"
+fi
+host="$1"
+shift
+
+if [ $# -eq 0 ]; then
+ err_exit "missing command argument"
+fi
+
+cmd="\"\$SHELL\" -ilc 'trap '\''ret=\$? ; [ \$ret -eq 0 ] || print -u2 -- \"[exited with status \$ret]\" ; exec \"\$SHELL\"'\'' EXIT INT ; $*'"
+
+exec ssh -t "$host" -- tmux new-session ${detach:+-d} ${session:+-s \"$session\"} ${window:+-n \"$window\"} "$cmd"
Generated by cgit. See skreutz.com for my tech blog and contact information.